//>>built
define("dijit/Editor",["require","dojo/_base/array","dojo/_base/declare","dojo/Deferred","dojo/i18n","dojo/dom-attr","dojo/dom-class","dojo/dom-geometry","dojo/dom-style","dojo/keys","dojo/_base/lang","dojo/sniff","dojo/string","dojo/topic","./_Container","./Toolbar","./ToolbarSeparator","./layout/_LayoutWidget","./form/ToggleButton","./_editor/_Plugin","./_editor/plugins/EnterKeyHandling","./_editor/html","./_editor/range","./_editor/RichText","./main","dojo/i18n!./_editor/nls/commands"],function(e,r,a,t,i,d,l,o,n,s,f,m,v,u,h,y,w,M,c,g,p,k,b,F,I){function z(e){return new g({command:e.name})}function A(e){return new g({buttonClass:c,command:e.name})}var j=a("dijit.Editor",F,{plugins:null,extraPlugins:null,constructor:function(){f.isArray(this.plugins)||(this.plugins=["undo","redo","|","cut","copy","paste","|","bold","italic","underline","strikethrough","|","insertOrderedList","insertUnorderedList","indent","outdent","|","justifyLeft","justifyRight","justifyCenter","justifyFull",p]),this._plugins=[],this._editInterval=1e3*this.editActionInterval,(m("ie")||m("trident")||m("edge"))&&(this.events.push("onBeforeDeactivate"),this.events.push("onBeforeActivate"))},postMixInProperties:function(){this.setValueDeferred=new t,this.inherited(arguments)},postCreate:function(){this.inherited(arguments),this._steps=this._steps.slice(0),this._undoedSteps=this._undoedSteps.slice(0),f.isArray(this.extraPlugins)&&(this.plugins=this.plugins.concat(this.extraPlugins)),this.commands=i.getLocalization("dijit._editor","commands",this.lang),m("webkit")&&n.set(this.domNode,"KhtmlUserSelect","none")},startup:function(){this.inherited(arguments),this.toolbar||(this.toolbar=new y({ownerDocument:this.ownerDocument,dir:this.dir,lang:this.lang,"aria-label":this.id}),this.header.appendChild(this.toolbar.domNode)),r.forEach(this.plugins,this.addPlugin,this),this.setValueDeferred.resolve(!0),l.add(this.iframe.parentNode,"dijitEditorIFrameContainer"),l.add(this.iframe,"dijitEditorIFrame"),d.set(this.iframe,"allowTransparency",!0),this.toolbar.startup(),this.onNormalizedDisplayChanged()},destroy:function(){r.forEach(this._plugins,function(e){e&&e.destroy&&e.destroy()}),this._plugins=[],this.toolbar.destroyRecursive(),delete this.toolbar,this.inherited(arguments)},addPlugin:function(r,a){var t=f.isString(r)?{name:r}:f.isFunction(r)?{ctor:r}:r;if(!t.setEditor){var i={args:t,plugin:null,editor:this};if(t.name&&(g.registry[t.name]?i.plugin=g.registry[t.name](t):u.publish(I._scopeName+".Editor.getPlugin",i)),!i.plugin)try{var d=t.ctor||f.getObject(t.name)||e(t.name);d&&(i.plugin=new d(t))}catch(e){throw new Error(this.id+": cannot find plugin ["+t.name+"]")}if(!i.plugin)throw new Error(this.id+": cannot find plugin ["+t.name+"]");r=i.plugin}arguments.length>1?this._plugins[a]=r:this._plugins.push(r),r.setEditor(this),f.isFunction(r.setToolbar)&&r.setToolbar(this.toolbar)},resize:function(e){e&&M.prototype.resize.apply(this,arguments)},layout:function(){var e=this._contentBox.h-(this.getHeaderHeight()+this.getFooterHeight()+o.getPadBorderExtents(this.iframe.parentNode).h+o.getMarginExtents(this.iframe.parentNode).h);this.editingArea.style.height=e+"px",this.iframe&&(this.iframe.style.height="100%"),this._layoutMode=!0},_onIEMouseDown:function(e){var r,a=this.document.body,t=a.clientWidth,i=a.clientHeight,d=a.clientLeft,l=a.offsetWidth,o=a.offsetHeight,n=a.offsetLeft;/^rtl$/i.test(a.dir||"")?t<l&&e.x>t&&e.x<l&&(r=!0):e.x<d&&e.x>n&&(r=!0),r||i<o&&e.y>i&&e.y<o&&(r=!0),r||(delete this._cursorToStart,delete this._savedSelection,"BODY"==e.target.tagName&&this.defer("placeCursorAtEnd"),this.inherited(arguments))},onBeforeActivate:function(){this._restoreSelection()},onBeforeDeactivate:function(e){this.customUndo&&this.endEditing(!0),"BODY"!=e.target.tagName&&this._saveSelection()},customUndo:!0,editActionInterval:3,beginEditing:function(e){this._inEditing||(this._inEditing=!0,this._beginEditing(e)),this.editActionInterval>0&&(this._editTimer&&this._editTimer.remove(),this._editTimer=this.defer("endEditing",this._editInterval))},_steps:[],_undoedSteps:[],execCommand:function(e){if(!this.customUndo||"undo"!=e&&"redo"!=e){this.customUndo&&(this.endEditing(),this._beginEditing());var r=this.inherited(arguments);return this.customUndo&&this._endEditing(),r}return this[e]()},_pasteImpl:function(){return this._clipboardCommand("paste")},_cutImpl:function(){return this._clipboardCommand("cut")},_copyImpl:function(){return this._clipboardCommand("copy")},_clipboardCommand:function(e){var r;try{if(r=this.document.execCommand(e,!1,null),m("webkit")&&!r)throw{}}catch(i){var a=v.substitute,t={cut:"X",copy:"C",paste:"V"};alert(a(this.commands.systemShortcut,[this.commands[e],a(this.commands[m("mac")?"appleKey":"ctrlKey"],[t[e]])])),r=!1}return r},queryCommandEnabled:function(e){return!this.customUndo||"undo"!=e&&"redo"!=e?this.inherited(arguments):"undo"==e?this._steps.length>1:this._undoedSteps.length>0},_moveToBookmark:function(e){var a,t,i,d,l=e.mark,o=e.mark,n=e.isCollapsed;o&&(m("ie")<9||9===m("ie")&&m("quirks")?f.isArray(o)?(l=[],r.forEach(o,function(e){l.push(b.getNode(e,this.editNode))},this),this.selection.moveToBookmark({mark:l,isCollapsed:n})):o.startContainer&&o.endContainer&&(d=b.getSelection(this.window))&&d.removeAllRanges&&(d.removeAllRanges(),a=b.create(this.window),t=b.getNode(o.startContainer,this.editNode),i=b.getNode(o.endContainer,this.editNode),t&&i&&(a.setStart(t,o.startOffset),a.setEnd(i,o.endOffset),d.addRange(a))):(d=b.getSelection(this.window))&&d.removeAllRanges&&(d.removeAllRanges(),a=b.create(this.window),t=b.getNode(o.startContainer,this.editNode),i=b.getNode(o.endContainer,this.editNode),t&&i&&(a.setStart(t,o.startOffset),a.setEnd(i,o.endOffset),d.addRange(a))))},_changeToStep:function(e,r){this.setValue(r.text);var a=r.bookmark;a&&this._moveToBookmark(a)},undo:function(){var e=!1;if(!this._undoRedoActive){this._undoRedoActive=!0,this.endEditing(!0);var r=this._steps.pop();r&&this._steps.length>0&&(this.focus(),this._changeToStep(r,this._steps[this._steps.length-1]),this._undoedSteps.push(r),this.onDisplayChanged(),delete this._undoRedoActive,e=!0),delete this._undoRedoActive}return e},redo:function(){var e=!1;if(!this._undoRedoActive){this._undoRedoActive=!0,this.endEditing(!0);var r=this._undoedSteps.pop();r&&this._steps.length>0&&(this.focus(),this._changeToStep(this._steps[this._steps.length-1],r),this._steps.push(r),this.onDisplayChanged(),e=!0),delete this._undoRedoActive}return e},endEditing:function(e){this._editTimer&&(this._editTimer=this._editTimer.remove()),this._inEditing&&(this._endEditing(e),this._inEditing=!1)},_getBookmark:function(){var e=this.selection.getBookmark(),a=[];if(e&&e.mark){var t=e.mark;if(m("ie")<9||9===m("ie")&&m("quirks")){var i=b.getSelection(this.window);if(f.isArray(t))r.forEach(e.mark,function(e){a.push(b.getIndex(e,this.editNode).o)},this),e.mark=a;else if(i){var d;i.rangeCount&&(d=i.getRangeAt(0)),e.mark=d?d.cloneRange():this.selection.getBookmark()}}try{e.mark&&e.mark.startContainer&&(a=b.getIndex(e.mark.startContainer,this.editNode).o,e.mark={startContainer:a,startOffset:e.mark.startOffset,endContainer:e.mark.endContainer===e.mark.startContainer?a:b.getIndex(e.mark.endContainer,this.editNode).o,endOffset:e.mark.endOffset})}catch(r){e.mark=null}}return e},_beginEditing:function(){0===this._steps.length&&this._steps.push({text:k.getChildrenHtml(this.editNode),bookmark:this._getBookmark()})},_endEditing:function(){var e=k.getChildrenHtml(this.editNode);this._undoedSteps=[],this._steps.push({text:e,bookmark:this._getBookmark()})},onKeyDown:function(e){if(m("ie")||this.iframe||e.keyCode!=s.TAB||this.tabIndent||this._saveSelection(),!this.customUndo)return void this.inherited(arguments);var r=e.keyCode;if(e.ctrlKey&&!e.shiftKey&&!e.altKey){if(90==r||122==r)return e.stopPropagation(),e.preventDefault(),void this.undo();if(89==r||121==r)return e.stopPropagation(),e.preventDefault(),void this.redo()}switch(this.inherited(arguments),r){case s.ENTER:case s.BACKSPACE:case s.DELETE:this.beginEditing();break;case 88:case 86:if(e.ctrlKey&&!e.altKey&&!e.metaKey){this.endEditing(),88==e.keyCode?this.beginEditing("cut"):this.beginEditing("paste"),this.defer("endEditing",1);break}default:if(!e.ctrlKey&&!e.altKey&&!e.metaKey&&(e.keyCode<s.F1||e.keyCode>s.F15)){this.beginEditing();break}case s.ALT:this.endEditing();break;case s.UP_ARROW:case s.DOWN_ARROW:case s.LEFT_ARROW:case s.RIGHT_ARROW:case s.HOME:case s.END:case s.PAGE_UP:case s.PAGE_DOWN:this.endEditing(!0);break;case s.CTRL:case s.SHIFT:case s.TAB:}},_onBlur:function(){this.inherited(arguments),this.endEditing(!0)},_saveSelection:function(){try{this._savedSelection=this._getBookmark()}catch(e){}},_restoreSelection:function(){this._savedSelection&&(delete this._cursorToStart,this.selection.isCollapsed()&&this._moveToBookmark(this._savedSelection),delete this._savedSelection)},onClick:function(){this.endEditing(!0),this.inherited(arguments)},replaceValue:function(e){this.customUndo?this.isClosed?this.setValue(e):(this.beginEditing(),e||(e="&#160;"),this.setValue(e),this.endEditing()):this.inherited(arguments)},_setDisabledAttr:function(e){this.setValueDeferred.then(f.hitch(this,function(){!this.disabled&&e||!this._buttonEnabledPlugins&&e?r.forEach(this._plugins,function(e){e.set("disabled",!0)}):this.disabled&&!e&&r.forEach(this._plugins,function(e){e.set("disabled",!1)})})),this.inherited(arguments)},_setStateClass:function(){try{this.inherited(arguments),this.document&&this.document.body&&(n.set(this.document.body,"color",n.get(this.iframe,"color")),n.set(this.document.body,"background-color",n.get(this.iframe,"background-color")))}catch(e){}}});return f.mixin(g.registry,{undo:z,redo:z,cut:z,copy:z,paste:z,insertOrderedList:z,insertUnorderedList:z,indent:z,outdent:z,justifyCenter:z,justifyFull:z,justifyLeft:z,justifyRight:z,delete:z,selectAll:z,removeFormat:z,unlink:z,insertHorizontalRule:z,bold:A,italic:A,underline:A,strikethrough:A,subscript:A,superscript:A,"|":function(){return new g({setEditor:function(e){this.editor=e,this.button=new w({ownerDocument:e.ownerDocument})}})}}),j});//# sourceMappingURL=Editor.js.map